'''
Created on Mar 31, 2014

@author: Justin
'''

import ECS
from Physics import Rectangle

class BoobyTrap(ECS.Component):
    '''
    This component allows the entity to be thrown
    towards the player when the player is in a certain
    area.
    '''


    def __init__(self, x, y, width, height, velocity, activatorEntType):
        '''
        x, y, width and height define a rectangle that will be tested for intersection
        against all entities of activatorEntType.
        '''
        super(BoobyTrap, self).__init__(type(self).__name__)
        self.boundingBox = Rectangle(x, y, width, height)
        self.velocity = velocity
        self.activatorEntType = activatorEntType

class TrapSystem(ECS.System):
    '''
    This system controls BoobyTraps and makes them move when they should.
    '''
    
    def __init__(self, systemManager):
        super(TrapSystem, self).__init__(systemManager, [("BoobyTrap", "PhysicsInfo")], 0, False)

    def update(self, dt):
            for ent in self.entities:
                if (ent.hasComponent("BoobyTrap")):
                    trap = ent.getComponent("BoobyTrap")
                    
                    for ent2 in self.systemManager.getEntsOfType(trap.activatorEntType):
                        if (ent2.hasComponent("PhysicsInfo")):
                            phys2 = ent2.getComponent("PhysicsInfo")
                            if ((not phys2.boundingBox is None) and trap.boundingBox.intersects(phys2.boundingBox)):
                                phys = ent.getComponent("PhysicsInfo")
                                phys.velocity = trap.velocity
                        